<SCRIPT LANGUAGE="VBScript">
Option Explicit

' xmessageflag.vbs
' -------------------------------
' Net at Work Netzwerksysteme GmbH
' Hoppenhof 32
' 33104 Paderbron
' http://www.netatwork.de
'  Net at Work 2002-2003
' -------------------------------
' SMTP Transport Event Sink to limit the size of MessageIDs
' Running as SMTP transport Event Sink
' -------------------------------
' Datum: 16.12.2004
' Erstellt durch: fcarius

' Pfad und Dateiname der Log-Datei
Const LogFile = "C:\xmessageflag\xmessageflag.log"
' errorlogging  0=no logging, 1=Fatal  2=Error 3=Warning 4=information  5=debug
Const LogLevel = 5

Sub ISMTPOnArrival_OnArrival(ByVal objMessage, EventStatus)
	On Error Resume Next

	AppendLog "Skript started", 4

	Dim mail
	Dim Fields
	Dim Field
	Dim objStream
	Dim xmessageflag

	Set Fields = objMessage.Fields
	Set Field = Fields("urn:schemas:mailheader:x-message-flag")
	xmessageflag = Field.Value
	AppendLog "xmessageflag:"&xmessageflag, 4

	if (len(Field.Value) > 0) Then
	AppendLog "xmessageflag exists !!!", 5
		set objStream = objMessage.GetStream
		if (err.number <> 0) Then AppendLog err.Description, 2
		AppendLog "GetStream successful", 5
		mail = replace(objStream.ReadText, xmessageflag, "removed by EventSink")
		AppendLog "Replace done", 5
		objStream.Position = 0
		objStream.WriteText(mail)
		objStream.SetEOS
		objStream.Flush
		if (err.number <> 0) Then AppendLog err.Description, 2
		objMessage.DataSource.Save  ' write back to CDO-object
		AppendLog "Object written", 5
	end if

	if (err.number <> 0) Then AppendLog err.Description, true
	AppendLog "Skript beendet", 4
	EventStatus = 0				     ' Done, means cdoRunNextSink
End Sub

Sub AppendLog(strLog, errlevel)
'Fgt einen Eintrag in die Log-Datei ein
	Dim file
	Dim fs

	if loglevel>=errlevel then
		Set fs = CreateObject("Scripting.FileSystemObject")
		Set file = fs.OpenTextFile(logfile, 8, true)
		file.Write(Now & ",")
		select case errlevel
			case 1	file.Write("Fatal Line" & err.Source)
			case 2	file.Write("Error")
			case 3	file.Write("Warning")
			case 4	file.Write("Information")
			case 5	file.Write("Debug")
			case else file.Write("Code:"&errlevel)
		end select
		file.WriteLine(","&strLog)
		file.Close
	end if
End Sub

</SCRIPT>